#include "ti86asm.inc"
#include ti86math.inc
#include ti86ops.inc
_asap_ind                 equ         0D623h
_formReal                        equ            5191h
.org _asm_exec_ram
input:
	call  _clrLCD
	ld hl,$0000
	ld (_curCol),hl
	ld (_curRow),hl
	ld hl,x1
	ld de,$c324
	ld bc,5;include ending 0
	ldir
	ld      a,0Dh
	ld      (_asap_ind),a
	call    _exec_pg3
	call _OP1TOOP6;			op6=x1
	ld hl,y1
	ld de,$c324
	ld bc,5;include ending 0
	ldir
	ld      a,0Dh
	ld      (_asap_ind),a
	call    _exec_pg3
	call _OP1TOOP5;			op6=x1,op5=y1
	ld hl,x2
	ld de,$c324
	ld bc,5;include ending 0
	ldir
	ld      a,0Dh
	ld      (_asap_ind),a
	call    _exec_pg3
	call _OP1TOOP4;			op6=x1,op5=y1,op4=x2
	ld hl,y2
	ld de,$c324
	ld bc,5;include ending 0
	ldir
	ld      a,0Dh
	ld      (_asap_ind),a
	call    _exec_pg3
	call _OP1TOOP3			;op6=x1,op5=y1,op4=x2,op3=y2
	call _PUSH_OP4
	call _PUSH_OP6
	call _PUSH_OP3
	call _PUSH_OP5			;stack: y1,y2,x1,x2
	call _OP6TOOP1
	call _OP4TOOP2
	call _FPADD
	call _OP2SET2
	call _FPDIV
	call _clrLCD
	ld a,$0
	ld (_curRow),a
	ld (_curCol),a
	ld hl,midpoint
	call _puts
	ld a,$1
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	ld hl,x
	call _puts
	call _dispop1a
	call _POP_OP1
	call _POP_OP2
	call _PUSH_OP2
	call _PUSH_OP1			;stack: y1,y2,x1,x2
	call _FPADD
	call _OP2SET2
	call _FPDIV
	ld a,$2
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	ld hl,y
	call _puts
	call _dispop1a
	call _POP_OP1
	call _POP_OP2
	call _POP_OP3
	call _POP_OP4		;op1=y1,op2=y2,op3=x1,op4=x2
	call _PUSH_OP4
	call _PUSH_OP3
	call _PUSH_OP2
	call _PUSH_OP1		;stack: y1,y2,x1,x2
	call _FPSUB
	call _OP1TOOP5
	call _OP3TOOP1
	call _OP4TOOP2
	call _FPSUB
	call _OP1TOOP2
	call _OP5TOOP1
	call _FPDIV
	ld a,$3
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	ld hl,slope
	call _puts
	ld a,0
	ld (_curCol),a
	ld a,$4
	ld (_curRow),a
	call _dispop1a
	call _POP_OP1
	call _POP_OP2		;op1=y1,op2=y2
	call _FPSUB
	call _FPSQUARE
	call _OP1TOOP6
	call _POP_OP1
	call _POP_OP2		;op1=x1,op2=x2
	call _FPSUB
	call _FPSQUARE
	call _OP6TOOP2
	call _FPADD
	ld a,0
	ld (_curCol),a
	ld a,5
	ld (_curRow),a
	ld hl,distance
	call _puts
	ld a,0
	ld (_curCol),a
	ld a,6
	ld (_curRow),a
	ld hl,sqroot
	call _puts
	call _dispop1a
	ret
_dispop1a:
    ld      a,48
    call    _formReal
    ld      hl,_OP3
    call    _puts
    ret
x1:
	.db "x1=?",0
x2:
	.db "x2=?",0
y1:
	.db "y1=?",0
y2:
	.db "y2=?",0
x:
	.db "x=",0
y:
	.db "y=",0
midpoint:
	.db "Midpoint:",0
slope:
	.db "Slope:",0
distance:
	.db "Distance:",0
sqroot:
	.db 16,0
.end
